package mydb

import "git.hexq.cn/tiglog/mydb/internal/adapter"

// RawExpr represents a raw (non-filtered) expression.
type RawExpr = adapter.RawExpr

// Raw marks chunks of data as protected, so they pass directly to the query
// without any filtering. Use with care.
//
// Example:
//
//	// SOUNDEX('Hello')
//	Raw("SOUNDEX('Hello')")
func Raw(value string, args ...interface{}) *RawExpr {
	return adapter.NewRawExpr(value, args)
}
